------------------------- ANIMLIB v3 - (c) 2011 Chimecho @ Gcrew - www.gcrew.es -------------------------

anim = {}

function anim.refresh(obj)
  if obj.tim_act:time() >= obj.tim then
    obj.tim_act:reset()
    obj.frame = obj.frame + 1
  end
  if obj.frame > obj.frames then obj.frame = 1 end
  obj.imgs[obj.frame]:rotate(obj.ang)
end

function anim.blit(obj,x,y)
  anim.refresh(obj)
  local w = obj.imgs[obj.frame]:width()
  local h = obj.imgs[obj.frame]:height()
  obj.imgs[obj.frame]:blit(x+w/2,y+h/2)
end

function anim.fxtint(obj,x,y,color)
  anim.refresh(obj)
  local w = obj.imgs[obj.frame]:width()
  local h = obj.imgs[obj.frame]:height()
  image.fxtint(x+w/2,y+h/2,obj.imgs[obj.frame],color)
end

function anim.fxadd(obj,x,y,color)
  anim.refresh(obj)
  local w = obj.imgs[obj.frame]:width()
  local h = obj.imgs[obj.frame]:height()
  image.fxadd(x+w/2,y+h/2,obj.imgs[obj.frame],color)
end

function anim.fxsub(obj,x,y,color)
  anim.refresh(obj)
  local w = obj.imgs[obj.frame]:width()
  local h = obj.imgs[obj.frame]:height()
  image.fxsub(x+w/2,y+h/2,obj.imgs[obj.frame],color)
end

function anim.blend(obj,x,y,alfa)
  anim.refresh(obj)
  local w = obj.imgs[obj.frame]:width()
  local h = obj.imgs[obj.frame]:height()
  image.blend(x+w/2,y+h/2,obj.imgs[obj.frame],alfa)
end

function anim.setframe(obj,frame)
  obj.tim_act:reset()
  obj.frame = math.min(frame,obj.frames)
end

function anim.rotate(obj,ang)
  obj.ang = ang
end

function anim.start(obj)
  obj.tim_act:start()
  obj.stat = "run"
end

function anim.runonce(obj)
  obj.tim_act:reset()
  obj.tim_act:start()
  obj.stat = "runonce"
end

function anim.pause(obj)
  obj.tim_act:reset()
  obj.tim_act:stop()
  obj.stat = "stop"
end

function anim.reset(obj)
  obj.tim_act:reset()
  if obj.stat=="stop" or obj.stat=="end" then
    obj.tim_act:stop()
  end
  obj.frame = 1
end

function anim.currentframe(obj)
  return obj.frame
end

function anim.free(obj)
  for i=1,#obj.imgs do
    obj.imgs[i]:free()
  end
end

function anim.create(imgs, w, h, tiempo) -- tabla con imagenes, tiempo entre cuadro y cuadro en milisegundos
  args = 4
  if not tiempo then tiempo = w; args = 2 end
  
  animobj = {w=0, h=0, blit = anim.blit, fxtint = anim.fxtint, fxadd = anim.fxadd, fxsub = anim.fxsub, blend = anim.blend, rotate = anim.rotate, setframe = anim.setframe, start = anim.start, pause = anim.pause, reset = anim.reset, currentframe = anim.currentframe, free = anim.free, ang = 0, frame = 1, frames = 0, imgs = {}, tim = tiempo, tim_act = timer.new(), state="stop"}
  
  if args == 2 then -- anim.create(imgs,tiempo)
    animobj.imgs = imgs
  elseif args == 4 then -- anim.create(spritesheet o ruta,w,h,tiempo)
    if type(imgs) == "string" then
      imgs = image.load(imgs)
    end
    local indice = 1
    local cw = math.floor(imgs:realwidth()/w)
    local ch = math.floor(imgs:realheight()/h)
    for j=1,ch do
      for i = 1,cw do
        animobj.imgs[indice] = image.create(w,h,0x0)
        animobj.imgs[indice]:blit(0,0,imgs,(i-1)*w,(j-1)*h,w,h)
        indice = indice + 1
      end
    end
    imgs:free()
  end
  
  animobj.w = animobj.imgs[1]:realwidth()
  animobj.h = animobj.imgs[1]:realheight()
  animobj.frames = #animobj.imgs
  animobj.tim_act:reset()
  animobj.tim_act:stop()
  return animobj
end

-------------------------------------- ANIMRING v1 by CHIMECHO -------------------------------------
-- Copylefts bla bla bla
-- Rollazo del autor
-- y.. prohibidio usarlo en el psp gnesis!

function screen.width() return 480 end
function screen.height() return 272 end

animring = {}
function animring.order(tbl)
	local ordr = {} -- zm, pos, esto va a ordernar segun el zoom, las mas chicas primero, las mas grandes despues...
	for i=1,#tbl do
		table.insert(ordr,{zm=tbl[i].zoom,pos=i})
	end
	table.sort(ordr,function (a,b) return a.zm < b.zm end)
	return ordr
end

function animring.rotate(opt, des) -- opciones, desfase de la primera imagen
	local ang_act = des
	for i=1,#opt do
		opt[i].ang = ang_act
		opt[i].x = math.cos(math.rad(opt[i].ang)) * opt.w/2
		opt[i].y = math.sin(math.rad(opt[i].ang)) * opt.h/2 -- los mas chiquitos, arriba
		opt[i].zoom = (1 + math.sin(math.rad(opt[i].ang)) * 0.2)
		opt[i].w = opt[i].anims.anim.w * opt[i].zoom
		opt[i].h = opt[i].anims.anim.h * opt[i].zoom 
		ang_act = ang_act - opt.ang
	end
	opt.orden = animring.order(opt)
end

function animring.blit(obj,desfx,desfy) -- objeto animring, desfase en x, desfase en y
	if not desfx then desfx = 0 end
	if not desfy then desfy = 0 end
	if controls.press("right") and obj.dir=="stop" then obj.endang = obj.anganillo + obj.ang; obj.dir = "right"; if obj[obj.op].anims.loop then obj[obj.op].anims.anim:pause(); obj[obj.op].anims.anim:reset(); end obj.op = obj.op + 1; end
	if controls.press("left") and obj.dir=="stop" then obj.endang = obj.anganillo - obj.ang; obj.dir = "left" if obj[obj.op].anims.loop then obj[obj.op].anims.anim:pause(); obj[obj.op].anims.anim:reset(); end obj.op = obj.op - 1; end
	if controls.up() then obj.desy=math.max(obj.desy-0.1,-1) end
	if controls.down() then obj.desy=math.min(obj.desy+0.1,1) end
	
	if obj.op>obj.cant_op then
		obj.op=1
	elseif obj.op<1 then
		obj.op=obj.cant_op
	end
	
	if obj.dir=="right" then
		obj.angulo = obj.angulo + (obj.ang/10) -- que la anim siempre dure 10 frames
		obj.anganillo = obj.anganillo + (obj.ang/10)
		animring.rotate(obj, obj.anganillo)
		if obj.angulo>=obj.ang then -- solo hasta el siguiente elemento
			obj.dir="stop"
			obj.angulo = 0
			obj.anganillo = obj.endang
		end
	elseif obj.dir=="left" then
		obj.angulo = obj.angulo - (obj.ang/10)
		obj.anganillo = obj.anganillo - (obj.ang/10)
		animring.rotate(obj, obj.anganillo)
		if obj.angulo<=-obj.ang then
			obj.dir="stop"
			obj.angulo = 0
			obj.anganillo = obj.endang
		end
	end
	
	if obj[obj.op].anims.loop then obj[obj.op].anims.anim:start(); end
	
	for j=1,#obj do
		i=obj.orden[j].pos
		obj[i].anims.anim:blend(desfx + screen.width()/2 + obj[i].x - (obj[i].w/2), desfy + screen.height()/2 + (obj[i].y * obj.desy) - (obj[i].h/2), (obj[i].zoom-0.2)*obj.alfa) -- centrado y con zoom
	end
	
	return obj.op
end

function animring.setframe(obj,op,frame)
	op = math.min(op,#obj)
	obj[op].anims.anim:setframe(frame)
	if not obj[op].anims.loop then obj[op].anims.anim:pause() end -- si no es un loop, pausarla...
end

function animring.currentframe(obj,op)
	op = math.min(op,#obj)
	return obj[op].anims.anim:currentframe()
end

function animring.resize(obj,w,h)
	obj.w = w
	obj.h = h
	animring.rotate(obj, obj.anganillo) -- para que se aplique el efecto
end

function animring.setalfa(obj,alfa)
	obj.alfa = alfa
end

function animring.free(obj)
	for i=1,#obj do
		obj[i].anims.anim:free()
	end
end

function animring.create(w,h,anims_tbl) -- ancho del anillo, alto del anillo, animaciones loops o animaciones estaticas
	local cant_op = #anims_tbl
	local ang = 180 - (((cant_op - 2)/cant_op)*180) -- angulo entre cada vertice del poligono, fuente: wikipedia
	local ring = {orden = {}, w = w, h = h, ang = ang, anganillo = 90, angulo = 0, dir = "stop", desy = 1, blit = animring.blit, free = animring.free, setframe = animring.setframe, currentframe = animring.currentframe, resize = animring.resize, setalfa = animring.setalfa, op = 1, cant_op = cant_op, alfa = 255}
	for i=1,cant_op do
		ring[i] = {anims = anims_tbl[i]}
	end
	animring.rotate(ring, ring.anganillo)
	return ring
end
-------------------------------------- HASTA AKI LA LIB -------------------------------------

-- USO:

-- menu = animring.create(w,h,anims)
--	 Crea un objeto de tipo animring
--	 w = ancho del anillo
--	 h = alto del anillo
--	 anims = tabla con animaciones del men del tipo {anim = animacion creada con animlib, loop = true o false}
--		loop = true: una animacin que se reproduce infinitamente
--		loop = false: slo se muestra un frame esttico, y se puede setear con animring.setframe(menu,opcion,frame) o menu:setframe(opcion,frame)
--	 Devuelve: un objeto de tipo animring

-- menu:blit([desx[,desy]]) o animring.blit(menu,[desx[,desy]])
--	Blitea el men de tipo anillo, centrado (esto si no hay desfases)
--	desx = desfase en x, si no se especifica, ser 0
--	desy = desfase en y, si no se especifica, ser 0
--	Devuelve: la opcin actual